

{ HYPNOMAP VERSION 1.0  - A SELF HYPNOSIS, MIND MAPPING & SPEED READING AID}
{ Copyright (C) 1995 Steve Murray   This program is free software; you}
{can redistribute it and/or modify         }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation; either version 1, or (at your option)}
{ any later version.  }

{ This program is distributed in the hope that it will be useful,  }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of}
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  }
{ GNU General Public License for more details.     }

{ You should have received a copy of the GNU General Public License}
{ along with this program; if not, write to the Free Software }
{ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. }

{ The author can always be contacted at the address}
{ 51 Turret Road, Knightswood, Glasgow G13 2HQ, Scotland, Great Britain }
{ or (not guaranteed) via electronic mail, currently (June 1995) }
{ murrays@dcs.gla.ac.uk     or    8736191m@udcf.gla.ac.uk }
{ Alternatively refer to the usenet newsgroup alt.hypnosis.}

{ You are encouraged to develop and enhance the program and to distribute }
{ it. Whilst money is not sought by the author feedback and information  }
{ certainly are - you are encouraged to send the author any  information }
{ you can to do with hypnosis, NLP, mind-mapping, speed-reading etc.    }
{ I am particulary keen to receive other people's computer mind-maps, }
{ either created with this program or the excellent INFO MAP or   }
{ MIND MAP PLUS programs (Trademarks acknowledged.) }
{ Most importantly of all I am extremely keen to receive comments and }
{ ideas on the program itself, it's usefulness and development possibilities,}
{ porting it to other platforms (please do!) and enhancing it's effectiveness.}
{ suggestion module files, phrase files, map files, speed read input files,}
{anything and everything is most welcome. I am particularly keen to acquire}
{ mind-maps people have created of popular psychology and self-help books,}
{ particularly the contents and section headings, which can often be} 
{ highly useful and idea-stimulating without one even having to read the}
{ book. Should anyone want to send money in support of the program, in }
{ the interests of netiquette I would prefer if you sent books or information}
{ files instead - since that is what I would do with it anyway. }



PROGRAM HYPNOMAP; {a program that draws some boxes with the LINE procedure}

uses Crt,Dos,Graph,Incluvga,remember,spirals,Views,Objects,timer;

CONST
   ASET=['R','F','I','S'];
   FULLRECT=TRUE;            {display full rectangles or just sides}
   WIDTH=620;                 {max horizontal width of induction rectangles}
   VERSIONNO=17;               {current program version number - }
   AUTHORNAME='Steve Murray'; {last author of this version}
   HEIGHT=460;                {max vertical width of induction rectangles}
   MODE=6;                    {start in screen mode 6 as normal}
   COMPILED=TRUE;             {boolean to vary speed if compiled -set by user}

   MAXDELAY=1000;             {constant for delay timing loop}
   TIMESTOSHOW=1;             {number of times the speed read text is shown}
   SLOWFACTOR=10;
   fastmult=0;

TYPE
   SUGGARRAY=ARRAY[1..100] OF CHAR;  {array to hold a suggestion phrase}

VAR

 sugcolor:Integer;
 linecolor:Integer;
 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;
 choice:char;
   DELAYMULT:Integer;              {multiplier for delay timing loop}
   DELSCALEMULT:Integer;            {multiplier for delay timing loop}
   PHRASEMULT:Integer;             {multiplier for phrase delay duration}
   SPEEDMULT:Integer;

var hour,minute,second,sec100,totsecs,startsecs,nummins,timelimit:Integer;
    phrasetime:integer;
    totsecstring:string;

NEXTSTEP:CHAR;        {program step being run}
DELAYSCALE:INTEGER;   {delay factor for program}
MORESTEPS:BOOLEAN;    {flag saying if this is the last step or not}
STEPVALFILE:TEXT;     {file holding steps}
   NUMWORDS:INTEGER;  {number of words in suggestion file}
   NUMTOSHOW:INTEGER;  {number of words to show}
   G:TEXT;
   CLAIM:CHAR;
   PITCHNO:INTEGER;
   TONEPITCH:INTEGER;   {tone variables}
   H:TEXT;
   I:TEXT;
   SPEEDFILE:TEXT;       {speed read input file}
   PHRASEFILE:TEXT;      {suggestion phrases input file}
   PHRASE:STRING;
   NUMPHRASES,MAXPHRASES:INTEGER;
   NUMSTEPS:INTEGER; {the number of stages of the program}
   STEPARRAY:ARRAY[1..20] OF CHAR;{holds program stages}
   STEPNO:INTEGER; {the number of the current stage}
   I1:INTEGER;
   MAXSIDE:INTEGER; {the number of boxes to draw on the screen}
   PC:INTEGER;
   PCTEMP:INTEGER;
   COUNT:INTEGER;
   L:Integer;
   STEP:INTEGER;       {the width between boxes}
   HSTEP:INTEGER;      {horizontal offset width for rectangles}
   F:TEXT;             {suggestion text file}
   SUGGESTION:STRING;  {string for a suggestion phrase}
   NUMSUGS:INTEGER;    {number of suggestions to show}
   LEFTCURS:INTEGER;   {cursor position for writing to screen}
   RIGHTCURS:INTEGER;
   VSTEP:INTEGER;      {vertical offset width for rectangles}
   fastwordfile:text;
  BLINK,SCRATCH,IMMUNE,LOVE,EYECLOSE,NEGTH,USERDEF:BOOLEAN;
MAINMODFILE:TEXT;
MODULENO:INTEGER;

  procedure setdelay;
  {sets the global variables for delay timing loops }
  var choice:char;

  begin;
  DELAYMULT:=15;              {multiplier for delay timing loop}
   DELSCALEMULT:=8;            {multiplier for delay timing loop}
   PHRASEMULT:=150;             {multiplier for phrase delay duration}
   SPEEDMULT:=50;
   WRITELN('Do you want to reset the delay timing loops?');
   READLN(CHOICE);
   IF (CHOICE='Y') or (CHOICE='y') then begin
   WRITELN('DELAYMULT IS',DELAYMULT,'NEW VALUE?');READLN(DELAYMULT);

  WRITELN('DELscaleMULT IS',DELscaleMULT,'NEW VALUE?');READLN(DELscaleMULT);
  WRITELN('phraseMULT IS',phraseMULT,'NEW VALUE?');READLN(phraseMULT);
  WRITELN('speedMULT IS',speedMULT,'NEW VALUE?');READLN(speedMULT);

   end; {if choice}

   end;{procedure}


 procedure startcolors;
 var choice:char;
 begin
 sugcolor:=1;
 linecolor:=1;
 Writeln('Change colors?');
 Readln(choice);
 if (choice='y') or (choice='Y') then begin
 Writeln('suggestion colour is',sugcolor);
 Writeln('New value?');
 Readln(sugcolor);

 Writeln('line colour is',linecolor);
 Writeln('New value?');
 Readln(linecolor);
 end;{if}
 end;{startcolors}


procedure gettimelimit;
begin
Writeln('Please enter a time limit for induction phase in seconds');
Readln(timelimit);
Writeln('please enter a time limit for phrase phase in seconds');
Readln(phrasetime);
end;

procedure Checktime;


begin

inttime(hour,minute,second,sec100);

end;

procedure Writetime;
begin
Writeln('The time is ',Hour:2,':',Minute:2,' and ',Second:2,'.',Sec100:2,' seconds.');
end;



function gettimestring:string;
var timestring:string;
begin
timestring:='';
Checktime;
timestring:=concat(timestring,chr(ord('0')+hour div 10));
timestring:=concat(timestring,chr(ord('0')+hour mod 10));
timestring:=concat(timestring,':');
timestring:=concat(timestring,chr(ord('0')+minute div 10));
timestring:=concat(timestring,chr(ord('0')+minute mod 10));
timestring:=concat(timestring,':');
timestring:=concat(timestring,chr(ord('0')+second div 10));
timestring:=concat(timestring,chr(ord('0')+second mod 10));
timestring:=concat(timestring,':');
{timestring:=concat(timestring,chr(ord('0')+sec100 div 10));}
{timestring:=concat(timestring,chr(ord('0')+sec100 mod 10));}
gettimestring:=timestring;
end;

procedure Writetimestring;
begin
Writeln(gettimestring);
end;


procedure Outtimexy(x,y:Integer);
begin
OUTTEXTXY(X,Y,gettimestring);

end;


procedure intgrph;
var graphcount:Integer;
begin
  grDriver := Detect;
 InitGraph(grDriver, grMode,' ');
 ErrCode := GraphResult;
 if ErrCode = grOk then
 begin  { Do graphics }

 for graphcount:=1 to 16 do
 begin
 Setgraphmode(graphcount);
  { Line(0, 0, GetMaxX, GetMaxY);}
  { Writeln(graphcount);}
 end; {for}



 end
 else
   Writeln('Graphics error:', GraphErrorMsg(ErrCode));
  { TextMode(C80 + Font8x8);}
end;


procedure draw(val1:Integer;val2:Integer;val3:Integer;val4:Integer;val5:Integer);
begin
line (val1,val2,val3,val4);
end;

PROCEDURE DRAWRECT(POS:INTEGER);
{draws a rectangle for the hypnospiral effect}
{left and right hand sides can be added by removing the brackets}
{from lines 2 and 4}
{this procedure will draw concentric rectangles if called with sequential}
{values of pos}

BEGIN
   DRAW (HSTEP+POS*HSTEP,VSTEP+POS*VSTEP,WIDTH-POS*HSTEP,VSTEP+POS*VSTEP,PC);
IF FULLRECT THEN DRAW (WIDTH-POS*HSTEP,VSTEP+POS*VSTEP,WIDTH-POS*HSTEP,HEIGHT-POS*VSTEP,PC);
   DRAW (WIDTH-POS*HSTEP,HEIGHT-POS*VSTEP,HSTEP+POS*HSTEP,HEIGHT-POS*VSTEP,PC);
IF FULLRECT THEN DRAW (HSTEP+POS*HSTEP,HEIGHT-POS*VSTEP,HSTEP+POS*HSTEP,VSTEP+POS*VSTEP,PC)
END;




PROCEDURE SCALEDELAY(FACTOR:INTEGER);
VAR CALCLENGTH,LENGTH1,LENGTH2:INTEGER;
VAR DUMMY:INTEGER;
VAR DUMCHAR:CHAR;
BEGIN
CALCLENGTH:=(MAXDELAY-(MAXDELAY-FACTOR))+1;
IF CALCLENGTH<>1 THEN BEGIN
FOR LENGTH1:=1 TO CALCLENGTH DO
BEGIN
FOR LENGTH2:=1 TO CALCLENGTH DO
BEGIN

END;{for}
END;{for}
END; {if}                   
END;{procedure}

procedure fastwords;
var fastwordstring:string;
    letter:char;
    x,y:integer;
    ellno:integer;
begin
x:=100;
y:=200;
Intgrph;

assign(fastwordfile,'fastword.txt');
reset(fastwordfile);
cleardevice;
setcolor(sugcolor);
fastwordstring:='';
letter:=' ';
ellno:=1;
  SetTextStyle(DefaultFont, HorizDir, 5);
while not eof(fastwordfile) do begin
ellno:=ellno+1;
setcolor(4);
{testellipse(ellno mod 36);}
If eoln(fastwordfile) then readln(fastwordfile);
repeat
Read(fastwordfile,letter);
until (letter <> ' ') or (eoln(fastwordfile));
repeat
fastwordstring:=concat(fastwordstring,letter);
read(fastwordfile,letter);
until eoln(fastwordfile) or (letter=' ');
fastwordstring:=concat(fastwordstring,letter);
setcolor(sugcolor);
outtextxy(x,y,fastwordstring);
scaledelay(delayscale*fastmult);
setcolor(0);
outtextxy(x,y,fastwordstring);
if ellno mod 6 =0 then testellipse(ellno mod 36);
fastwordstring:='';

end;{while}
end;{procedure}




PROCEDURE GETSTEPVALS;
BEGIN
ASSIGN(STEPVALFILE,'stepvals.txt');
RESET(STEPVALFILE);
READ(STEPVALFILE,HSTEP);
READ(STEPVALFILE,VSTEP);
READ(STEPVALFILE,MAXSIDE);
READ(STEPVALFILE,STEP);


CLOSE(STEPVALFILE);
END;


PROCEDURE DRAWFIRST(POS:INTEGER);
VAR TEMPH,TEMPV:INTEGER;
BEGIN
TEMPH:=HSTEP;
TEMPV:=VSTEP;
HSTEP:=2;
VSTEP:=2;
   DRAW (HSTEP+POS*HSTEP,VSTEP+POS*VSTEP,WIDTH-POS*HSTEP,VSTEP+POS*VSTEP,PC);
   DRAW (WIDTH-POS*HSTEP,VSTEP+POS*VSTEP,WIDTH-POS*HSTEP,HEIGHT-POS*VSTEP,PC);
   DRAW (WIDTH-POS*HSTEP,HEIGHT-POS*VSTEP,HSTEP+POS*HSTEP,HEIGHT-POS*VSTEP,PC);
   DRAW (HSTEP+POS*HSTEP,HEIGHT-POS*VSTEP,HSTEP+POS*HSTEP,VSTEP+POS*VSTEP,PC);
HSTEP:=TEMPH;
VSTEP:=TEMPV;


END;


PROCEDURE REST(DURATION:INTEGER);
VAR N:INTEGER;
BEGIN
IF COMPILED THEN DURATION:=DURATION*DELAYMULT;
  FOR N := 1 TO DURATION DO ;
END;

procedure tone(val1:Integer;val2:Integer);
begin
sound(val1*30);
delay(val2);
nosound;
end;


procedure setstepvals;
var choice:char;

begin
Writeln('reset hypnospiral step parameters?');
Readln(choice);
if (choice='y') or (choice='Y') then begin



Writeln('hstep is',hstep);
writeln('new value?');
readln(hstep);

Writeln('vstep is',vstep);
writeln('new value?');
readln(vstep);

Writeln('maxside is',maxside);
writeln('new value?');
readln(maxside);

Writeln('step is',step);
writeln('new value?');
readln(step);

end;{if choice}





end;{procedure}


procedure censtr(var instring:string);
const maxstrlen =35;
var lenstrng:integer;
    leftspaces,rightspaces:Integer;
    numshifts:integer;
    shiftno:integer;
    letter:integer;
begin


while length(instring) <maxstrlen do begin
instring:=concat(' ',instring);
instring:=concat(instring,' ');

end;{while}

leftspaces:=1;
while (instring[leftspaces]=' ') do begin
leftspaces:=leftspaces+1;
end;{while}

rightspaces:=1;
while (instring[rightspaces]=' ') do begin
rightspaces:=rightspaces+1;
end;{while}

if abs(leftspaces-rightspaces) > 1 then begin
numshifts:=abs(leftspaces-rightspaces) div 2;

if leftspaces > rightspaces then begin
for shiftno :=1 to numshifts do begin

for letter:= 2 to length(instring) do begin
instring[letter-1]:=instring[letter];
leftspaces:=leftspaces-1;
rightspaces:=rightspaces+1;
end;{for letter}

end;{for shiftno}

end;{if leftspaces}



if rightspaces > leftspaces then begin
for shiftno :=1 to numshifts do begin

for letter:=1 to length(instring)-1 do begin
instring[letter+1]:=instring[letter];
leftspaces:=leftspaces+1;
rightspaces:=rightspaces-1;
end;{for letter}

end;{for shiftno}

end;{if leftspaces}

end;{if abs}
end;{procedure}
procedure cls;
begin
CLRSCR;
end;

procedure cursor(val1:Integer;val2:Integer);
begin
Gotoxy(val1,val2);
end;

procedure setmode(val:Integer);
begin
end;

PROCEDURE MAINBODY;
VAR NUMWORDS:INTEGER;
    graphcount:Integer;
    curcolor,coltoset:integer;
    numnotes,numdivs:Integer;
BEGIN;
NUMWORDS:=1;


   grDriver := Detect;
 InitGraph(grDriver, grMode,' ');
 ErrCode := GraphResult;
 if ErrCode = grOk then
 begin  { Do graphics }

 for graphcount:=1 to 16 do
 begin
 Setgraphmode(graphcount);
  { Line(0, 0, GetMaxX, GetMaxY);}
  { Writeln(graphcount);}
 end; {for}



 end
 else
   Writeln('Graphics error:', GraphErrorMsg(ErrCode));
  { TextMode(C80 + Font8x8);}
  setcolor(linecolor);
   DRAWFIRST(0);
   DRAW(STEP,HEIGHT-1,WIDTH-1,HEIGHT-1,PC);
   PITCHNO:=0;
    SetTextStyle(DefaultFont, HorizDir, 2);
    checktime;
    startsecs:=second;
   WHILE  (NOT EOF(G)) AND (totsecs<timelimit) DO
     BEGIN



   FOR I1 := 1 TO MAXSIDE DO
      BEGIN


        SCALEDELAY(DELAYSCALE+(PITCHNO*SLOWFACTOR ));
        DRAWRECT(I1);

      END; {for I1}
      NUMNOTES:=16;
      NUMDIVS:=NUMTOSHOW DIV NUMNOTES;

      PITCHNO:=(NUMWORDS DIV NUMDIVS );



      TONE(NUMNOTES-PITCHNO,100);



      READLN(G,SUGGESTION);



      curcolor:=getcolor;
      coltoset:=getbkcolor;

      SETCOLOR(coltoset);

      FOR I1:=1 TO MAXSIDE DO
      BEGIN
      SCALEDELAY(DELAYSCALE+(PITCHNO*SLOWFACTOR));
      DRAWRECT(I1);
      END; {for I1}



      setcolor(curcolor);


     SCALEDELAY(DELAYSCALE+(PITCHNO*SLOWFACTOR));

    NUMWORDS:=NUMWORDS+1;
    IF EOF(G) THEN RESET(G);
    Cleardevice;
     SETCOLOR(sugcolor);
     OUTTEXTXY(160,220,SUGGESTION);
     inttime(hour,minute,second,sec100);
     {OUTTIMEXY(60,400);}
     SETCOLOR(linecolor);
     if second mod 60 = 0 then nummins:=nummins+1;
     totsecs:=second-startsecs+nummins*60;

     str(totsecs,totsecstring);
     {outtextxy(60,420,totsecstring);}
     END;{while}




END;{MAINBODY}



PROCEDURE GETNEXTSTEP;
BEGIN
NEXTSTEP:=STEPARRAY[STEPNO];
STEPNO:=STEPNO+1;
IF STEPNO>NUMSTEPS THEN MORESTEPS:=FALSE;
END;
PROCEDURE PREPSUGS;
BEGIN
Intgrph;
settextstyle(DefaultFont, HorizDir, 3);
ASSIGN(PHRASEFILE,'prepsugs.txt');
RESET(PHRASEFILE);
{WRITELN('SUGGEST');}
cleardevice;


WHILE NOT EOF(PHRASEFILE) DO
BEGIN
{DRAWFIRST(0);}


READLN(PHRASEFILE,PHRASE);
setcolor(sugcolor);
outtextxy(10,220,PHRASE);
SCALEDELAY(DELAYSCALE*PHRASEMULT);
setcolor(0);
outtextxy(10,220,phrase);

{IF (MAXPHRASES MOD NUMPHRASES) MOD 8 = 0 THEN }
{REMEMBER;}





END;{while}
CLOSE(PHRASEFILE);




END;{procedure}


PROCEDURE SUGGEST;
BEGIN
prepsugs;
totsecs:=0;

ASSIGN(PHRASEFILE,'phrases.txt');
RESET(PHRASEFILE);
{WRITELN('SUGGEST');}
cleardevice;

 SetTextStyle(DefaultFont, HorizDir, 2);
 nummins:=0;
 checktime;
 startsecs:=second;
WHILE (NUMPHRASES<=MAXPHRASES) and (totsecs<phrasetime) DO

BEGIN
checktime;
{DRAWFIRST(0);}
totsecs:=second-startsecs+60*nummins;
if second mod 60 =0 then nummins:=nummins+1;
READLN(PHRASEFILE,PHRASE);
censtr(phrase);
OUTTEXTXY(0,230,PHRASE);
{IF (MAXPHRASES MOD NUMPHRASES) MOD 8 = 0 THEN }
{REMEMBER;}
SCALEDELAY(DELAYSCALE*PHRASEMULT);
if numphrases mod 5=0 then caption;
settextstyle(defaultfont,horizdir,2);
REST(5000);
setcolor(0);
outtextxy(0,230,phrase);
setcolor(sugcolor);
NUMPHRASES:=NUMPHRASES+1;
IF EOF(PHRASEFILE) THEN RESET(PHRASEFILE);
END;{while}
CLOSE(PHRASEFILE);


END;



PROCEDURE SPEEDREAD;
VAR ONELINE:STRING;
    LINENO:INTEGER;
    NUMPASSES:INTEGER;
BEGIN
CLOSEGRAPH;
LINENO:=1;
CLS;
FOR NUMPASSES:=1 TO TIMESTOSHOW DO BEGIN


RESET(SPEEDFILE);
WHILE NOT EOF(SPEEDFILE) DO BEGIN
READLN(SPEEDFILE,ONELINE);
LINENO:=LINENO+1;

IF (LINENO MOD 21) = 0 THEN BEGIN

REST(8000);
SCALEDELAY(DELAYSCALE*SPEEDMULT);
CLS;
END;{if}
WRITELN(ONELINE);
END;{while}

END;{for numpasses}
SETMODE(4);
READLN;

INTGRPH;
END;


PROCEDURE GETNUMTOSHOW;
BEGIN
WRITELN('HOW MANY SUGGESTIONS TO SHOW?');
READLN(NUMTOSHOW);
END;

PROCEDURE MAKESTEPARRAY;

VAR STEPCHAR:CHAR;
    NOKEY:CHAR;
    STEPSTRING:STRING;
BEGIN
ASSIGN(H,'stepfile.txt'); {file containing main run parameters}
RESET(H);
STEPNO:=0;
NUMSTEPS:=1;
READ(H,NUMPHRASES);
{WRITELN('NUMPHRASES IS', NUMPHRASES);}
{READLN(H);}
READ(H,MAXPHRASES);
READ(H,NUMTOSHOW);
READLN(H,STEPSTRING);
{READLN(H)}

{STEPSTRING:='SRE'; }
WRITELN('Stepstring is',STEPSTRING);
WRITELN('PLEASE ENTER STEP SEQUENCE: {I S R F E} ');
READLN(STEPSTRING);
STEPCHAR:='A';

WHILE STEPCHAR<>'E' do
BEGIN
STEPNO:=STEPNO+1;
STEPCHAR:=STEPSTRING[STEPNO];
STEPARRAY[STEPNO]:=STEPCHAR;

END;{while}
NUMSTEPS:=STEPNO;


END; {MAKESTEPARRAY}


PROCEDURE READDELAY;
BEGIN
ASSIGN(I,'delayfil.txt');
RESET(I);
READ(I,DELAYSCALE);
{DELAYSCALE:=4;}
END; {readdelay}

PROCEDURE TERMINATE;
BEGIN
Intgrph;
settextstyle(DefaultFont, HorizDir, 2);
ASSIGN(PHRASEFILE,'terminat.txt');
RESET(PHRASEFILE);
{WRITELN('SUGGEST');}
cleardevice;


WHILE NOT EOF(PHRASEFILE) DO
BEGIN
{DRAWFIRST(0);}


READLN(PHRASEFILE,PHRASE);
setcolor(sugcolor);
outtextxy(10,220,PHRASE);
SCALEDELAY(DELAYSCALE*PHRASEMULT);
setcolor(0);
outtextxy(10,220,phrase);

{IF (MAXPHRASES MOD NUMPHRASES) MOD 8 = 0 THEN }
{REMEMBER;}





END;{while}
CLOSE(PHRASEFILE);
TONE(7,900);



END;{procedure}



PROCEDURE SHOWDISCLAIMER;
BEGIN
CLS;
WRITELN('Hypnomap version ',VERSIONNO:3,' copyright 1995 Steve Murray ');
WRITELN('This program is free software - you may distribute it according');
WRITELN('to the terms of the GNU public license, either version 1 or at');
WRITELN('your option any later version. Please read the README file and');
WRITELN('the gnu public license file at least once.');
WRITELN;
WRITELN('If you have not yet read the accompanying instruction manual and');
WRITELN('the enclosed book on self hypnosis, or do not feel confident');
WRITELN('enough to take full responsibility for using the program ');
WRITELN('for your own good please read more before using it since confidence');
WRITELN('and knowing what to do at each stage can be highly instrumental in success.');
WRITELN('Have you read the instruction manual / book? (Y/N)');
READLN(CLAIM);
IF (CLAIM <>'Y') AND (CLAIM <>'y') THEN WRITE('Please do so before ');
WRITELN('running the program');
end;{procedure}

procedure regdrivs;
begin
 if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Writeln('oh dear - no egavga driver');
end;
{MAIN BODY}

procedure remakephrases;
const numphraslim = 25;
type phrasearray=array[1..numphraslim] of string;
var phrasefile:text;
    count:Integer;
    newphrase:string;
    phrases:phrasearray;
begin
assign(phrasefile,'phrases.txt');
rewrite(phrasefile);
Writeln('Please enter number of phrases to be input');
Readln(numphrases);
for count:=1 to numphrases do begin
Writeln('Please enter new phrase no ', count:1);
Readln(newphrase);
phrases[count]:=newphrase;
end;{for}

for count:=1 to numphrases do begin
Writeln(phrasefile,phrases[count]);
end;{for}
Close(phrasefile);

end{procedure};




procedure confirmparms;
var choice:char;
begin
READDELAY; {read in delay factor from file}
WRITELN('Current delay factor is ',DELAYSCALE);
WriteLN('New delay factor?');READLN(DELAYSCALE);
WRITELN('Speed decrease factor is (the lower the faster, minimum 100) ',numtoshow);
WRITELN('New factor');READLN(NUMTOSHOW);


WRITELN('REMAKE PHRASES?');
READLN(CHOICE);
IF (CHOICE='Y') or (CHOICE='y') then REMAKEPHRASES;
end;

BEGIN
{writetimestring;}
{readln;}
regdrivs;
sugcolor:=1;
linecolor:=1;

showdisclaimer;
IF COMPILED THEN DELAYSCALE:=DELAYSCALE*DELSCALEMULT;
READLN;
WRITELN('begindelay');
SCALEDELAY(1);

ASSIGN(H,'stepfile.txt'); {file containing main run parameters}
RESET(H);

ASSIGN(G,'testfile.txt'); {file containing induction suggestions}

ASSIGN(SPEEDFILE,'speedin.txt'); {file containing speed read text}
STEPNO:=1;
MAKESTEPARRAY;   {set up array for main run parameters}

RESET(G);        {open file with induction suggestions}
IF (CLAIM ='Y') OR (CLAIM ='y') THEN BEGIN


GETSTEPVALS;
Writeln('Confirm configuration options?');
Readln(Choice);
If (choice <>'N') and (choice <>'n') then begin
confirmparms;
startcolors;
setdelay;
setstepvals;


end;{if choice}

gettimelimit;



   LEFTCURS:=10*WIDTH MOD 310; {position cursor for writing induction text}
   RIGHTCURS:=14;

  { MAXSIDE:=15;  }      {number of hypnospiral lines to draw}
                       {this times STEP should be between 55-75}





{MAINBODY;}
 {for debugging}
MORESTEPS:=TRUE;
STEPNO:=1;
WHILE MORESTEPS DO
BEGIN{while moresteps}
GETNEXTSTEP;
{NEXTSTEP:='I';}
{WRITELN('STEPNO IS ',STEPNO:2);}
{WRITELN('NEXTSTEP IS');}


{extra line added for test}
{SUGGEST;}
{SPEEDREAD;}
{end of extra line}


IF NEXTSTEP<>'E' THEN MORESTEPS:=TRUE;
IF MORESTEPS THEN
CASE NEXTSTEP OF

'I' : MAINBODY;

'S' : SUGGEST;

'R' : SPEEDREAD;

'F' : FASTWORDS;

END; {CASE}

END; {WHILE MORESTEPS DO}

TERMINATE;

END; {if claim}






END.



